//Class used for storing data of the current user 
int threshold1 = 600; // threshold for incorrect data test received by kinect.
int frameDistanceThreshould = 200; // threshold for data display in canvas
public class UserTrackingInfo {
  public ArrayList<PVector> positions;
  public ArrayList<PImage> photos;
  public ArrayList<PShape> shapes;
  public ArrayList<Float> phases;
  public PVector colour;
  private PVector lastP;
  

  public UserTrackingInfo() {
    positions = new ArrayList<PVector>();
    photos = new ArrayList<PImage>();
    shapes = new ArrayList<PShape>();
    phases = new ArrayList<Float>();
    positions.add(new PVector(0, 0, 0));
    shapes.add(createShape(SPHERE, 1, 1, 1));
    photos.add(new PImage());
    phases.add(0f);
    lastP = positions.get(positions.size() - 1);
    colour = new PVector(random(0, 255), random(0, 255), random(0, 255));
  }

  public void update(PVector currentP, PImage imageInput) {
    lastP = positions.get(positions.size()-1);
    println("new image, photos.size() = "+photos.size());
    if (currentP.x==0 && currentP.y ==0 && currentP.z ==0 ) {
      return;
    }
    if (positions.size() == 1) {
      positions.add(currentP);
      photos.add(imageInput);
    } else {
      if ((!this.isDumb(currentP)) && this.isFarEnough(currentP) ) {
        positions.add(currentP);
        photos.add(imageInput);
      }
    }
  }

  public void update(PVector currentP, PShape shapeInput,float phaseInput) {
    lastP = positions.get(positions.size()-1);
    if (currentP.x==0 && currentP.y ==0 && currentP.z ==0 ) {
      return;
    }
    if (positions.size() == 1) {
      positions.add(currentP);
      shapes.add(shapeInput);
      phases.add(phaseInput);
    } else {
      if ((!this.isDumb(currentP)) && this.isFarEnough(currentP) ) {
        positions.add(currentP);
        shapes.add(shapeInput);
        phases.add(phaseInput);
      }
    }
  }

  private boolean isDumb(PVector currentP) {
    if (abs(currentP.x - lastP.x) > threshold1) {
      return true;
    } else if (abs(currentP.y - lastP.y) > threshold1) {
      return true;
    } else if (abs(currentP.z - lastP.z) > threshold1) {
      return true;
    } else return false;
  }

  private boolean isFarEnough(PVector currentP) {
    //float displacement = v_dist(currentP, lastP);
    //boolean result = true;
//    if (displacement >=  frameDistanceThreshould) return true;
//    else return false;


    for (int i = 0; i<positions.size (); i++) {
      float displacement = v_dist(currentP, positions.get(i));
      //println("i = "+i+"                  displacement = "+displacement);
      if (displacement <  frameDistanceThreshould) {
      //println("short");
        return false;
      }
    }
    return true;
  }
};

