

//  This is a project for the depth concetp
//  This would be used for MAT265 course by Prof. George Legrady in 2016 Spring.
// 
//  This program only runs in Processing 2 since some of libraries are not supported in other version of Processing. 
//  Please sucessfully connect a Kinect or Xtion before run this program.
//
//  Author: Zhenyu Yang
//  Date: 04/12/2016
//
//  Thanks for help from  Hilda Chang HE and guide by Prof. George Legrady.
//
//  Interation: Press P key to stop drawing new sculpture.


import peasy.*;
import SimpleOpenNI.*;
import java.util.Iterator;
PeasyCam cam;

SimpleOpenNI context;

boolean photo = true;
boolean ifSculpture = true;
int         steps           = 4; // to speed up the drawing, draw every third point 3

PImage img;
PImage ground;
PImage maskImage;
// width, height are given as window sizes
int screen_width = 1024; 
int screen_height = 700; 
float depth = 500;
float camDepth = 2000;

// Distance between the camera and the screen in the virtual space.
float camera_screen_distance = 4500; //500

//Boundary and initial values 
float left = -100;
float right = 100;
float top = -100;
float bottom = 100;
float back = 50;
float front = -500;

// SIZES
int canvasWidth  = 640;
int canvasHeight = 480;

int kinectWidth  = 640;
int kinectHeight = 480;

int[] depthValues;

int minDistance  = 500;  // 50cm
int maxDistance  = 1500; // 1.5m
int distanceThreshould = 250;

float groundScale = 0.8;

int a=0;
int bb =0;
int c = 0;

// Initialize OpenNI or not (for debugging).
boolean initialize_openni = true;
// Show hand positions (for debugging).
boolean show_Com_vectors = true;
boolean draw_boundary = true;
boolean draw_path = true;

// User tracking information.
HashMap<Integer, UserTrackingInfo> user_tracking_info = new HashMap<Integer, UserTrackingInfo>();

//avoid concurency modification
Object lock = new Object();

// Previous update time.
double previous_update_time;

//User location
PVector com;

//initiate time
float time;
int fadeSpeed = 100; // larger -> faster
int alphaThreshold = 80;//transparency

//distance measurement
float distance = 0;

//parameters for sculptures
float       strokeW         = 0.6;

PVector   s_rwp = new PVector(); // standarized realWorldPoint;
int       kdh;
int       kdw;
int       max_edge_len = 50000; //50
float     strokeWgt = 0;//0.4
int       i00, i01, i10, i11; // indices
PVector   p00, p10, p01, p11; // points
PVector   k_rwp; // kinect realWorldPoint;

PImage marble;
PShape square;

int red = 225;
int green = 225;
int blue = 255;

void setup() {
  ground = loadImage("woods.jpg");
  marble = loadImage("marble.jpg");
  maskImage  = createImage(kinectWidth, kinectHeight, RGB);

  if (ifSculpture) {
    frameDistanceThreshould = 200;
    cam = new PeasyCam(this, width / 2, height / 2, -depth - camera_screen_distance, back + camDepth);
  } else {
    frameDistanceThreshould = 25;
    cam = new PeasyCam(this, 1200);
  }

  // Initialize screen.
  // OpenGL rendering.
  size(screen_width, screen_height, P3D);

  // Initialize OpenNI.
  if (initialize_openni) {
    context = new SimpleOpenNI(this);
    if (context.isInit() == false) {
      println("Can't init SimpleOpenNI, maybe the camera is not connected!");
      exit();
      return;
    }
  } else {
    context = null;
  }
  if (context != null) {
    // Disable mirror.
    context.setMirror(true);
    // Seems it stops randomly crashing if we enable depth.
    context.enableDepth();
    // Enable user tracking.
    context.enableUser();
    context.enableRGB();
    context.update();
    com = new PVector(); // user location
  }
  //peasyCam
  //set frameRate
  frameRate(20);
  //set time
  time = 0.00;
  //hint(DISABLE_DEPTH_TEST);
  kdh = context.depthHeight();
  kdw = context.depthWidth();

  square = createShape(BOX, kdh, kdw, 50);
  square.scale(0.5); //0.1+1.0/(2*p.z));
  //square.setTexture(marble);
}

// Translate OpenNI space into image space.
// GL: translates the sensing distance from /real space sensing to virtual space
PVector translateOpenNIPosition(PVector position) {
  float x = -position.x;
  float y = -position.y;
  float z = position.z;// (position.z - 1000);
  return new PVector(x, y, z);
}

// Update hand positions.
// We don't actually use this, but this function could be useful.
void updateHandPoses() {
  // Calculate dt (in seconds).
  double current_time = millis();
  float dt = (float)(current_time - previous_update_time) / 1000.0;
  previous_update_time = current_time;

  // Read OpenNI data and update user hand positions and velocities.
  if (context != null) {
    // Get forces.
    int[] user_list = context.getUsers();
    for (int i = 0; i < user_list.length; i++) {
      if (context.isTrackingSkeleton(user_list[i])) {
        int user_id = user_list[i];
        PVector left_hand_position = new PVector();
        PVector right_hand_position = new PVector();
        float left_hand_confidence = context.getJointPositionSkeleton(user_id, SimpleOpenNI.SKEL_LEFT_HAND, left_hand_position);
        float right_hand_confidence = context.getJointPositionSkeleton(user_id, SimpleOpenNI.SKEL_RIGHT_HAND, right_hand_position);
        left_hand_position = translateOpenNIPosition(left_hand_position);
        right_hand_position = translateOpenNIPosition(right_hand_position);
        UserTrackingInfo info = user_tracking_info.get(user_id);
      }
    }
  }
}
//Update user position 
void updateUserPoses() {
  if (context != null) {
    int[] user_list = context.getUsers();

    for (int i = 0; i < user_list.length; i++) {
      //println("test for distance use " + i +":  "+ user_list[i]);
      if (context.getCoM(user_list[i], com)) {
        int user_id = user_list[i];
        if (com != null && user_tracking_info.get(user_id) != null&&photo) {
          if (ifSculpture) {
            PVector[] depthPoints = context.depthMapRealWorld(); 
            float thres = 200;
            //float thres = com.z+distanceThreshould;
            if (strokeWgt == 0) 
              noStroke();
            else strokeWeight(strokeWgt);
            for (int y = 0; y < kdh; y+=steps) {
              for (int x = 0; x < kdw; x+= steps) { 
                int counter = y * kdw + x;
                PVector p = depthPoints[counter];
                // if the point is on the edge or if it has no depth
                if (p.z < com.z - thres || p.z > com.z+thres || y == 0 || y == kdh - steps || x == 0 || x == kdw - steps) {
                  // replace it with a point at the depth of the backplane (i.e. maxZ)
                  PVector realWorld = new PVector();
                  //PVector projective = new PVector(x*(thres*1.0/p.z), y*(thres*1.0/p.z), thres);
                  PVector projective = new PVector(x, y, com.z+thres);
                  // to get the point in the right place, we need to translate
                  // from x/y to realworld coordinates to match our other points:
                  context.convertProjectiveToRealWorld(projective, realWorld);
                  depthPoints[counter] = realWorld;
                  //depthPoints[i] = projective;
                }
              }
            }
            PShape tempShape  = createShape();
            tempShape.beginShape(TRIANGLES);  

            for (int y=0; y < kdh-steps; y+=steps) {
              int y_steps_kdw = (y+steps)*kdw;
              int y_kdw = y * kdw;
              for (int x=0; x < kdw-steps; x+=steps)
              {
                i00 = x + y_kdw;
                i01 = x + y_steps_kdw;
                i10 = (x + steps) + y_kdw;
                i11 = (x + steps) + y_steps_kdw;
                p00 = depthPoints[i00];
                p01 = depthPoints[i01];
                p10 = depthPoints[i10];
                p11 = depthPoints[i11];
                if ((p00.z > 0) && (p01.z > 0) && (p10.z > 0) && // check for non valid values
                (abs(p00.z-p01.z) < max_edge_len) && (abs(p10.z-p01.z) < max_edge_len)) { // check for edge length
                  tempShape.vertex(p00.x, p00.y, p00.z, x, y); // x,y,x,u,v   position + texture reference
                  tempShape.vertex(p01.x, p01.y, p01.z, x, y+steps);
                  tempShape.vertex(p10.x, p10.y, p10.z, x+steps, y);
                }

                if ((p11.z > 0) && (p01.z > 0) && (p10.z > 0) &&(abs(p11.z-p01.z) < max_edge_len) && (abs(p10.z-p01.z) < max_edge_len)) {
                  tempShape.vertex(p01.x, p01.y, p01.z, x, y+steps);
                  tempShape.vertex(p11.x, p11.y, p11.z, x+steps, y+steps);
                  tempShape.vertex(p10.x, p10.y, p10.z, x+steps, y);
                }
                // endShape();
              }
            }
            tempShape.scale(0.1+1.0/(2*com.z)); 
            tempShape.endShape();
            user_tracking_info.get(user_id).update(new PVector(com.x, com.y, com.z), tempShape, (random(PI)-PI/2.0));
          } else {
            depthValues = context.depthMap();
            maskImage.loadPixels();
            for (int pic = 0; pic < depthValues.length; pic++)
              //if (depthValues[pic] > minDistance && depthValues[pic] < maxDistance)
              if (depthValues[pic] > com.z-distanceThreshould && depthValues[pic] < com.z+distanceThreshould)
                // IN RANGE: WHITE PIXEL
                maskImage.pixels[pic] = color(255);
              else
                maskImage.pixels[pic] = color(0);
            maskImage.updatePixels();
            // BLUR THE B/W IMAGE
            superFastBlur(3);
            // MASK THE RGB CAM IMAGE
            PImage rgbImage =  context.rgbImage();
            rgbImage.mask(maskImage);
            PImage temp = new PImage();
            temp = rgbImage.get(0, 0, rgbImage.width, rgbImage.height); 
            user_tracking_info.get(user_id).update(new PVector(com.x, com.y, com.z), temp);
          }
        }
      }
    }
  }
}

//Update the box boundary, which is the border of our movement. 
void updateBoxBoundary() {
  // Read OpenNI data and update boundary
  if (context != null) {
    // iteration
    int[] user_list = context.getUsers();
    for (int i = 0; i < user_list.length; i++) {
      if (context.getCoM(user_list[i], com)) {
        PVector p = translateOpenNIPosition(com);
        //println("User Location: x(" + p.x + ") y(" + p.y + ") z(" + p.z+")");
        if (p.x < left ) {
          left = p.x;
          //println("Update LEFT, x = " + left );
        } else if (p.x > right) {
          right = p.x; 
          //println("Update RIGHT, x = ", + right );
        }
        if (p.y < top ) {
          top = p.y;
          //println("Update TOP, y = " + top );
        } else if (p.y > bottom ) {
          bottom = p.y;
          //println("Update BOTTOM, y = " + bottom );
        }
        if (p.z > back) {
          back = p.z;
          //println("Update BACK, z = " + back );
          //change camera distance
          cam.setDistance(back + camDepth);
        }
      }
    }
  }
}
void draw() {
  background(0);

  pointLight(red, green, blue, 10000, -10000, -20000);
  pointLight(red, green, blue, 0, 0, 20000);
  pointLight(red/3, green/3, blue/3, -1000, 0, 0);
  pointLight(red/5, green/5, blue/5, 0, 10000, 0);
  pointLight(red, green, blue, 0, -20000, 0);

  if (ifSculpture) {
    pushMatrix();
    translate(-1000, 100, 0);
    for (int i = 0; i<50; i++) {
      for (int j = 0; j<50; j++) {
        pushMatrix();
        translate(i*100, 0, j*100);
        line(-100, 0, 0, 100, 0, 0);
        //rotateY(PI/2);
        line(0, 0, -100, 0, 0, 100);
        popMatrix();
      }
    }
    popMatrix();
  }
  if (context != null) context.update();
  synchronized (lock) {
    //updateHandPoses();
    updateBoxBoundary();
    updateUserPoses();
    //translate(width / 2, height / 2, -depth - camera_screen_distance);

    Iterator<Integer> it;


    //draw user position 
    if (show_Com_vectors) {
      stroke(255, 255, 255);
      fill(255, 255, 255);

      it = user_tracking_info.keySet().iterator();
      if (context != null) {
        // iteration
        int[] user_list = context.getUsers(); // =========================
        for (int i = 0; i < user_list.length; i++) {
          if (context.getCoM(user_list[i], com)) {
            PVector p = translateOpenNIPosition(com);
            //println("User Location: x(" + p.x + ") y(" + p.y + ") z(" + p.z+")");
            drawBox(p.x, p.y, p.z);
            float dist = sqrt((p.x/22.7)*(p.x/22.7) + (p.y/22.7)*(p.y/22.7) + (p.z/22.7)*(p.z/22.7));
            fill(255);
            textSize(24);
            text("Distance: " + (int)dist + " inch", p.x-25, p.y+25, p.z);
          }
        }
      }
    }
    if (draw_path) {
      it = user_tracking_info.keySet().iterator();
      if (context != null) {
        while (it.hasNext ()) {
          int user_id = it.next();
          UserTrackingInfo info = user_tracking_info.get(user_id);

          stroke(info.colour.x, info.colour.y, info.colour.z);
          for (int i = 1; i < info.positions.size (); i++) {
            //println("i: " + i);
            PVector p = translateOpenNIPosition(info.positions.get(i));
            if (ifSculpture) {
              PShape shape = info.shapes.get(i); 
              pushMatrix();
              translate(p.x, -70, p.z*2);
              rotateY(PI);
              rotateZ(PI);
              rotateY(info.phases.get(i));
              shape(shape);
              translate(0, 0, p.z*(0.1+1.0/(2*p.z))+25);
              shape(square);
              popMatrix();
            } else {
              PImage rgbImage = info.photos.get(i);
              pushMatrix();
              translate(p.x, p.y, p.z);
              image(rgbImage, 0, 0, 100, 100);
              popMatrix();
            }
          }
        }
      }
    }
  }

  time += 0.01;
}

//draw a small cude by given parameters
void drawBox(float x, float y, float z) {
  pushMatrix();
  translate(x, y, z);
  box(20, 20, 20);
  popMatrix();
}


// -----------------------------------------------------------------
// SimpleOpenNI user events
//event handler when found new user
void onNewUser(SimpleOpenNI current_context, int user_id) {
  synchronized (lock) {
    println("New user: id = " + user_id + ", started tracking.");
    user_tracking_info.put(user_id, new UserTrackingInfo());
    //context.startTrackingSkeleton(user_id);
  }
}

//event handler when lost track of this user
void onLostUser(SimpleOpenNI current_context, int user_id) {
  synchronized (lock) {
    println("Lost user: id = " + user_id);
    UserTrackingInfo info = user_tracking_info.get(user_id);
    //user_tracking_info.remove(user_id);
  }
}

void keyPressed() {
  if (key == 'p' || key== 'P') {
    photo =! photo;
  }
}

